/* Alter table in target */
ALTER TABLE `cat_configuracion` 
	ADD COLUMN `url_sync_ventas` TEXT  COLLATE utf8_general_ci NULL AFTER `url_sync_usuarios`, COMMENT='';

/* Alter table in target */
ALTER TABLE `cat_productos_servicios` 
	ADD COLUMN `modelo` VARCHAR(100)  COLLATE latin1_swedish_ci NULL AFTER `descripcion`, 
	CHANGE `cant_min` `cant_min` FLOAT(10,3)   NULL AFTER `modelo`, 
	CHANGE `cant_deseada` `cant_deseada` FLOAT(10,3)   NULL AFTER `cant_min`, 
	CHANGE `precio_venta` `precio_venta` DECIMAL(15,2)   NULL AFTER `cant_deseada`, 
	CHANGE `precio_mayoreo` `precio_mayoreo` FLOAT(10,3)   NULL AFTER `precio_venta`, 
	CHANGE `tasa_iva` `tasa_iva` DECIMAL(7,2)   NULL AFTER `precio_mayoreo`, 
	CHANGE `peso` `peso` VARCHAR(15)  COLLATE latin1_swedish_ci NULL AFTER `tasa_iva`, 
	CHANGE `longitud` `longitud` VARCHAR(15)  COLLATE latin1_swedish_ci NULL AFTER `peso`, 
	CHANGE `superficie` `superficie` VARCHAR(15)  COLLATE latin1_swedish_ci NULL AFTER `longitud`, 
	CHANGE `volumen` `volumen` VARCHAR(15)  COLLATE latin1_swedish_ci NULL AFTER `superficie`, 
	CHANGE `id_unidad_medida` `id_unidad_medida` INT(11) UNSIGNED   NULL AFTER `volumen`, 
	CHANGE `tipo_producto` `tipo_producto` INT(5) UNSIGNED   NULL AFTER `id_unidad_medida`, 
	CHANGE `iva_incluido` `iva_incluido` INT(1) UNSIGNED   NULL AFTER `tipo_producto`, 
	CHANGE `cant_mayoreo` `cant_mayoreo` FLOAT(10,3)   NULL AFTER `iva_incluido`, 
	CHANGE `fecha_alta` `fecha_alta` DATETIME   NULL AFTER `cant_mayoreo`, 
	CHANGE `imagen` `imagen` MEDIUMBLOB   NULL AFTER `fecha_alta`, 
	CHANGE `notificacion` `notificacion` INT(1) UNSIGNED   NULL AFTER `imagen`, 
	CHANGE `fecha_modificacion` `fecha_modificacion` TIMESTAMP   NULL AFTER `notificacion`, COMMENT='';

/* Create table in target */
CREATE TABLE `tbl_cortes_caja`(
	`id_corte` INT(11) NOT NULL  AUTO_INCREMENT , 
	`fecha_corte` DATETIME NULL  , 
	`efectivo_caja` DECIMAL(15,2) NULL  , 
	`efectivo_real` DECIMAL(15,2) NULL  , 
	`diferencia` DECIMAL(15,2) NULL  , 
	`id_usuario_caja` INT(11) NULL  , 
	`id_usuario_corte` INT(11) NULL  , 
	PRIMARY KEY (`id_corte`) 
) ENGINE=INNODB DEFAULT CHARSET='latin1';


/* Create table in target */
CREATE TABLE `tbl_devoluciones`(
	`id_devolucion` INT(11) NOT NULL  AUTO_INCREMENT , 
	`fecha_devolucion` DATETIME NULL  , 
	`id_venta` INT(11) NULL  , 
	`id_producto` INT(11) NULL  , 
	`cantidad` INT(11) NULL  , 
	`precio_unitario` DECIMAL(15,2) NULL  , 
	`devolucion` DECIMAL(15,2) NULL  , 
	`id_usuario_caja` INT(11) NULL  , 
	`id_usuario_devolucion` INT(11) NULL  , 
	PRIMARY KEY (`id_devolucion`) 
) ENGINE=INNODB DEFAULT CHARSET='latin1';


/* Alter table in target */
ALTER TABLE `tbl_movimientos` 
	ADD COLUMN `descuento` DECIMAL(15,2)   NULL DEFAULT '0.00' AFTER `pagado`, 
	CHANGE `fecha_pago` `fecha_pago` DATETIME   NULL AFTER `descuento`, 
	CHANGE `fecha_cancelado` `fecha_cancelado` DATETIME   NULL AFTER `fecha_pago`, 
	CHANGE `consolidado` `consolidado` DATETIME   NULL AFTER `fecha_cancelado`, 
	CHANGE `id_usuario_venta` `id_usuario_venta` INT(11)   NULL AFTER `consolidado`, 
	CHANGE `id_usuario_pago` `id_usuario_pago` INT(11)   NULL AFTER `id_usuario_venta`, COMMENT='';

/* Create table in target */
CREATE TABLE `tbl_movimientos_pagos`(
	`id_movimiento` INT(11) NULL  , 
	`importe_cobro` DECIMAL(15,2) NULL  , 
	`descuento` DECIMAL(15,2) NULL  , 
	`id_forma_pago` INT(11) NULL  , 
	`fecha_pago` DATETIME NULL  , 
	`id_usuario_pago` INT(11) NULL  , 
	`id_usuario_descuento` INT(11) NULL  
) ENGINE=INNODB DEFAULT CHARSET='latin1';


/* Create table in target */
CREATE TABLE `tbl_retiros`(
	`id_retiro` INT(11) NOT NULL  AUTO_INCREMENT , 
	`fecha_retiro` DATETIME NULL  , 
	`efectivo_inicial` DECIMAL(15,2) NULL  , 
	`retiro` DECIMAL(15,2) NULL  , 
	`efectivo_final` DECIMAL(15,2) NULL  , 
	`id_usuario_caja` INT(11) NULL  , 
	`id_usuario_retiro` INT(11) NULL  , 
	PRIMARY KEY (`id_retiro`) 
) ENGINE=INNODB DEFAULT CHARSET='latin1';


/* Alter table in target */
ALTER TABLE `tbl_sincronizacion` 
	ADD COLUMN `sync_ventas` DATETIME   NULL AFTER `sync_usuarios`, COMMENT='';

/* Alter table in target */
ALTER TABLE `tbl_usuarios` 
	ADD COLUMN `permisos` TEXT  COLLATE utf8_general_ci NULL AFTER `nombre`, 
	CHANGE `activo` `activo` TINYINT(1)   NULL AFTER `permisos`, COMMENT='';
/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_buscarProducto`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_buscarProducto`(
	in_info TEXT
)
    SQL SECURITY INVOKER
    COMMENT 'Busca un producto por descripción, nombre, modelo o clave'
BEGIN
	SET in_info = CONCAT('%', in_info, '%');
	
	SELECT prd.*
	FROM cat_productos_servicios AS prd
	WHERE prd.clave LIKE in_info
		OR prd.modelo LIKE in_info
		OR prd.descripcion LIKE in_info
		OR prd.nombre LIKE in_info;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_cobroPedido`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_cobroPedido`(
	in_id_movimiento INT,
	in_cobro DECIMAL,
	in_descuento DECIMAL,
	in_forma_pago INT,
	in_factura BOOL,
	in_id_user INT,
	in_id_user_descuento INT
)
    SQL SECURITY INVOKER
    COMMENT 'Aplica el cobro a un pedido'
BEGIN
	UPDATE tbl_movimientos
	SET pagado = pagado + in_cobro + in_descuento,
		descuento = descuento + in_descuento,
		fecha_pago = NOW(),
		factura = in_factura,
		id_usuario_pago = in_id_user
	WHERE id_movimiento = in_id_movimiento;
	
	INSERT INTO tbl_movimientos_pagos
	SET id_movimiento = in_id_movimiento,
		importe_cobro = in_cobro,
		descuento = in_descuento,
		id_forma_pago = in_forma_pago,
		fecha_pago = NOW(),
		id_usuario_pago = in_id_user,
		id_usuario_descuento = in_id_user_descuento;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_configuracion`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_configuracion`()
    SQL SECURITY INVOKER
    COMMENT 'Obtiene la imagen por default para productos sin foto'
BEGIN
	SELECT cfg.id_sucursal,
		cfg.default_image,
		cfg.group_len,
		cfg.desglosa_total,
		cfg.url_existencias,
		cfg.url_sync_sucursales,
		cfg.url_sync_productos,
		cfg.url_sync_precios,
		cfg.url_sync_usuarios,
		cfg.url_sync_ventas
	FROM cat_configuracion AS cfg;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_cortecaja`(
	in_id_corte INT
)
    SQL SECURITY INVOKER
    COMMENT 'Informacion de corte de caja'
BEGIN
	SELECT cc.*,
		CAST(cc.fecha_corte AS DATE) AS fecha,
		SUBSTRING(cc.fecha_corte, 12) AS hora,
		uc.nombre AS usuario_caja,
		ua.nombre AS usuario_corte
	FROM tbl_cortes_caja AS cc
	JOIN tbl_usuarios AS uc
		ON uc.id_user = cc.id_usuario_caja
	JOIN tbl_usuarios AS ua
		ON ua.id_user = cc.id_usuario_corte
	WHERE cc.id_corte = in_id_corte;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_detalleMovimiento`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_detalleMovimiento`(
	in_id_movimiento INT
)
    SQL SECURITY INVOKER
    COMMENT 'Recupera los registros del detalle de un movimiento'
BEGIN
	SELECT dm.cantidad,
		prd.clave,
		prd.nombre AS descripcion,
		dm.precio_unitario,
		dm.precio_venta,
		dm.subtotal,
		dm.iva,
		dm.total,
		dm.tasa_iva,
		dm.iva_incluido,
		prd.imagen,
		dm.id_producto
	FROM tbl_movimientos_detalle AS dm
	JOIN cat_productos_servicios AS prd
		ON prd.id_producto = dm.id_producto
	WHERE dm.id_movimiento = in_id_movimiento;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_devolucion`(
	in_id_devolucion INT
)
    SQL SECURITY INVOKER
    COMMENT 'Informacion de devolucion'
BEGIN
	SELECT cc.*,
		CAST(cc.fecha_devolucion AS DATE) AS fecha,
		SUBSTRING(cc.fecha_devolucion, 12) AS hora,
		uc.nombre AS usuario_caja,
		ua.nombre AS usuario_devolucion
	FROM tbl_devoluciones AS cc
	JOIN tbl_usuarios AS uc
		ON uc.id_user = cc.id_usuario_caja
	JOIN tbl_usuarios AS ua
		ON ua.id_user = cc.id_usuario_devolucion
	WHERE cc.id_devolucion = in_id_devolucion;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_efectivoEnCaja`()
    SQL SECURITY INVOKER
    COMMENT 'Obtiene el importe de efectivo en caja actualmente'
BEGIN
	DECLARE efectivo DECIMAL(15,2);
	DECLARE retiros DECIMAL(15,2);
	DECLARE pagos DECIMAL(15,2);
	DECLARE fecha_corte DATETIME;
	SET efectivo = 0;
	SET retiros = 0;
	SET pagos = 0;
	SET fecha_corte = '2000-01-01';
	
	SELECT cc.efectivo_real, cc.fecha_corte INTO efectivo, fecha_corte
	FROM tbl_cortes_caja AS cc
	ORDER BY cc.fecha_corte DESC
	LIMIT 1;
	
	SELECT SUM(re.retiro) INTO retiros
	FROM tbl_retiros AS re
	WHERE re.fecha_retiro >= fecha_corte;
	
	SELECT SUM(p.importe_cobro) INTO pagos
	FROM tbl_movimientos_pagos AS p
	WHERE p.fecha_pago >= fecha_corte
		AND p.id_forma_pago = 0;
	
	-- Retorna el importe
	SELECT efectivo + COALESCE(pagos, 0) - COALESCE(retiros, 0) AS efectivo,
		efectivo, pagos, retiros;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_existeCorteCajaHoy`()
    SQL SECURITY INVOKER
    COMMENT 'Verifica si existe corte de caja del día en curso'
BEGIN
	DECLARE existeCorte INT;
	DECLARE hoy DATE;
	SET existeCorte = 0;
	SET hoy = CAST(NOW() AS DATE);
	
	SELECT 1 INTO existeCorte
	FROM tbl_cortes_caja AS cc
	WHERE CAST(cc.fecha_corte AS DATE) = hoy
	ORDER BY cc.fecha_corte DESC
	LIMIT 1;
	
	-- Retorna el resultado
	SELECT COALESCE(existeCorte, 0) AS existe_corte;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_insertarCorteCaja`(
	in_efectivo_caja DECIMAL(15,2),
	in_efectivo_real DECIMAL(15,2),
	in_id_user_caja INT,
	in_id_user_corte INT
)
    SQL SECURITY INVOKER
    COMMENT 'Agregar registro de corte de caja'
BEGIN
	INSERT INTO tbl_cortes_caja
	SET fecha_corte = NOW(),
		efectivo_caja = in_efectivo_caja,
		efectivo_real = in_efectivo_real,
		diferencia = efectivo_real - efectivo_caja,
		id_usuario_caja = in_id_user_caja,
		id_usuario_corte = in_id_user_corte;
	
	SET @id = LAST_INSERT_ID();
	
	-- Retorna ID del movimiento y # de Referencia
	SELECT  @id AS id_corte;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_insertarDevolucion`(
	in_id_venta INT,
	in_id_producto INT,
	in_cantidad INT,
	in_precio_unitario DECIMAL(15,2),
	in_id_user_caja INT,
	in_id_user_devolucion INT
)
    SQL SECURITY INVOKER
    COMMENT 'Agregar registro de devolución de producto'
BEGIN
	INSERT INTO tbl_devoluciones
	SET fecha_devolucion = NOW(),
		id_venta = in_id_venta,
		id_producto = in_id_producto,
		cantidad = in_cantidad,
		precio_unitario = in_precio_unitario,
		devolucion = precio_unitario * cantidad,
		id_usuario_caja = in_id_user_caja,
		id_usuario_devolucion = in_id_user_devolucion;
	
	SET @id = LAST_INSERT_ID();
	
	-- Retorna ID del movimiento y # de Referencia
	SELECT  @id AS id_devolucion;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_insertarMovimiento`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_insertarMovimiento`(
	in_id_movimiento INT,
	in_id_sucursal INT,
	in_id_tipo_movimiento INT,
	in_subtotal DECIMAL(15,2),
	in_iva	DECIMAL(15,2),
	in_total DECIMAL(15,2),
	in_id_user INT
)
    SQL SECURITY INVOKER
    COMMENT 'Guardar (INS/UPD) movimiento en la tabla de movimientos'
BEGIN
	SET @ref = CONCAT(CHAR(65 + FLOOR( 1 + RAND( ) * 25)), '-', LPAD(FLOOR( 1 + RAND( ) * 999999), 6, "0"));
	SET @hora = NOW();
	
	START TRANSACTION;
	SET @consecutivo = (
		SELECT COALESCE(MAX(consecutivo), 0) + 1
		FROM tbl_movimientos 
		WHERE fecha = CAST(@hora AS DATE)
	);
	
	INSERT INTO tbl_movimientos
	SET id_movimiento = in_id_movimiento,
		id_sucursal = in_id_sucursal,
		id_tipo_movimiento = in_id_tipo_movimiento,
		consecutivo = @consecutivo,
		referencia = @ref,
		hora = SUBSTR(@hora, 12, 8),
		fecha = CAST(@hora AS DATE),
		subtotal = in_subtotal,
		iva = in_iva,
		total = in_total,
		pagado = 0,
		id_usuario_venta = in_id_user
	ON DUPLICATE KEY
	UPDATE id_sucursal = in_id_sucursal,
		id_tipo_movimiento = in_id_tipo_movimiento,
		-- consecutivo = @consecutivo,
		-- referencia = @ref,
		hora = SUBSTR(@hora, 12, 8),
		fecha = CAST(@hora AS DATE),
		subtotal = in_subtotal,
		iva = in_iva,
		total = in_total;
		-- id_usuario_venta = in_id_user
	
	SET @id = COALESCE(in_id_movimiento, LAST_INSERT_ID());
	
	-- Cancela detalle de productos previos
	DELETE FROM tbl_movimientos_detalle
	WHERE id_movimiento = @id;
	
	COMMIT;
	
	-- Retorna ID del movimiento y # de Referencia
	SELECT  mov.id_movimiento, mov.referencia
	FROM tbl_movimientos AS mov
	WHERE mov.id_movimiento = @id;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_insertarRetiro`(
	in_inicial DECIMAL(15,2),
	in_retiro DECIMAL(15,2),
	in_id_user_caja INT,
	in_id_user_retiro INT
)
    SQL SECURITY INVOKER
    COMMENT 'Agregar registro de retiro de caja'
BEGIN
	INSERT INTO tbl_retiros
	SET fecha_retiro = NOW(),
		efectivo_inicial = in_inicial,
		retiro = in_retiro,
		efectivo_final = efectivo_inicial - retiro,
		id_usuario_caja = in_id_user_caja,
		id_usuario_retiro = in_id_user_retiro;
	
	SET @id = LAST_INSERT_ID();
	
	-- Retorna ID del movimiento y # de Referencia
	SELECT  @id AS id_retiro;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_listarPedidos`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_listarPedidos`(
	in_tipo_movimiento INT,
	in_fecha DATE
)
    SQL SECURITY INVOKER
    COMMENT 'Recupera los pedidos que no se han pagado aun'
BEGIN
	CASE in_tipo_movimiento
		WHEN 1 THEN
			-- Listar Pedidos
			SELECT mov.id_movimiento,
				mov.consecutivo,
				mov.fecha,
				mov.hora,
				CONCAT(IF(ISNULL(mov.fecha_cancelado), '', 'CANCELADO - '), mov.referencia) AS referencia,
				u.nombre AS nombre_vendedor,
				mov.total,
				mov.total - mov.pagado AS saldo,
				1 AS activo,
				IF(ISNULL(mov.consolidado), 1, 0) AS enviado
			FROM tbl_movimientos AS mov
			JOIN tbl_usuarios AS u
				ON u.id_user = mov.id_usuario_venta
			WHERE mov.pagado <> mov.total
				AND mov.fecha_cancelado IS NULL;
		WHEN 2 THEN
			-- Listar Ventas
			SELECT mov.id_movimiento,
				mov.consecutivo,
				mov.fecha,
				mov.hora,
				CONCAT(IF(ISNULL(mov.fecha_cancelado), '', 'CANCELADO - '), mov.referencia) AS referencia,
				u.nombre AS nombre_vendedor,
				mov.total,
				mov.total - mov.pagado AS saldo,
				0 AS activo,
				IF(ISNULL(mov.consolidado), 1, 0) AS enviado
			FROM tbl_movimientos AS mov
			JOIN tbl_usuarios AS u
				ON u.id_user = mov.id_usuario_venta
			WHERE mov.pagado = mov.total
				AND mov.fecha = in_fecha;
		WHEN 3 THEN
			-- Listar Cancelaciones
			SELECT mov.id_movimiento,
				mov.consecutivo,
				mov.fecha,
				mov.hora,
				CONCAT(IF(ISNULL(mov.fecha_cancelado), '', 'CANCELADO - '), mov.referencia) AS referencia,
				u.nombre AS nombre_vendedor,
				mov.total,
				mov.total - mov.pagado AS saldo,
				0 AS activo,
				IF(ISNULL(mov.consolidado), 1, 0) AS enviado
			FROM tbl_movimientos AS mov
			JOIN tbl_usuarios AS u
				ON u.id_user = mov.id_usuario_venta
			WHERE mov.fecha_cancelado IS NOT NULL;
		WHEN 4 THEN
			-- Listar Todos
			SELECT mov.id_movimiento,
				mov.consecutivo,
				mov.fecha,
				mov.hora,
				CONCAT(IF(ISNULL(mov.fecha_cancelado), '', 'CANCELADO - '), mov.referencia) AS referencia,
				u.nombre AS nombre_vendedor,
				mov.total,
				mov.total - mov.pagado AS saldo,
				IF(mov.pagado <> mov.total AND ISNULL(mov.fecha_cancelado), 1, 0) AS activo,
				IF(ISNULL(mov.consolidado), 1, 0) AS enviado
			FROM tbl_movimientos AS mov
			JOIN tbl_usuarios AS u
				ON u.id_user = mov.id_usuario_venta
			; -- HERE mov.pagado <> mov.total;
	END CASE;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_precioProducto`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_precioProducto`(
	in_id_sucursal INT,
	in_id_producto INT,
	in_cantidad INT
)
    SQL SECURITY INVOKER
    COMMENT 'Obtiene la imagen por default para productos sin foto'
BEGIN
	-- Valida si existen tabuladores de precios para la sucursal indicada
	IF EXISTS (
		SELECT id_producto FROM tbl_precios_productos
		WHERE id_sucursal = in_id_sucursal
			AND id_producto = in_id_producto
	) THEN
		-- Obtenemos el tabulador de precio en base a la cantidad para la sucursal.
		-- Si no se encuentra el tabulador correspondiente, devuelve precio general
		-- del producto.
		SELECT COALESCE(pp.precio, prd.precio_venta) AS precio_unitario
		FROM cat_productos_servicios AS prd
		LEFT OUTER JOIN tbl_precios_productos AS pp
			ON pp.id_producto = prd.id_producto
				AND pp.id_sucursal = in_id_sucursal
				AND pp.cantidad <= in_cantidad
		WHERE prd.id_producto = in_id_producto
		ORDER BY pp.cantidad DESC
		LIMIT 1;
	ELSE
		-- Si no existen tabuladores de precios definidos para la sucursal, obtenemos
		-- el tabulador de precios de la lista general de precios (id_sucursal = 0).
		-- Si no se encuentra el tabulador correspondiente, devuelve precio general
		-- del producto.
		SELECT COALESCE(pp.precio, prd.precio_venta) AS precio_unitario
		FROM cat_productos_servicios AS prd
		LEFT OUTER JOIN tbl_precios_productos AS pp
			ON pp.id_producto = prd.id_producto
				AND pp.id_sucursal = 0 -- ID 0 = Lista aplicable a todas las sucursales
				AND pp.cantidad <= in_cantidad
		WHERE prd.id_producto = in_id_producto
		ORDER BY pp.cantidad DESC
		LIMIT 1;
	END IF;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_precioProductoNew`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_precioProductoNew`(
	in_id_sucursal INT, 	-- ID de la sucursal que solicita precio
	in_id_producto INT, 	-- ID del producto solicitado
	in_cantidad INT 	-- Cantidad requerida del producto
)
    SQL SECURITY INVOKER
    COMMENT 'Obtiene la imagen por default para productos sin foto'
BEGIN
	SET @precio_unitario = NULL;
	SET @precio_mayoreo = 0.00;
	SET @oferta = 0;
	SET @cantidad = 0;
	
	-- Búsqueda de precio de oferta para el producto
	SELECT pof.precio,
		pof.precio,
		1 AS oferta
	INTO @precio_unitario,
		@precio_mayoreo,
		@oferta
	FROM tbl_precios_ofertas AS pof
	WHERE pof.id_producto = in_id_producto
		AND pof.id_sucursal IN (0, in_id_sucursal)
		AND CURDATE() BETWEEN pof.fecha_desde AND pof.fecha_hasta
	ORDER BY pof.id_sucursal DESC
	LIMIT 1;
	
	-- Si no hay precio de oferta, buscamos tabuladores de precios
	IF ISNULL(@precio_unitario) THEN
		-- valida si existen tabuladores de precios para la sucursal indicada
		IF EXISTS (
			SELECT ppro.id_producto
			FROM tbl_precios_productos AS ppro
			WHERE ppro.id_sucursal = in_id_sucursal
				AND ppro.id_producto = in_id_producto
		) THEN
			-- Obtenemos el tabulador de precio en base a la cantidad para la sucursal.
			-- Si no se encuentra el tabulador correspondiente, devuelve precio general
			-- del producto.
			SELECT COALESCE(pp.precio, prd.precio_venta),
				COALESCE(( -- Obtiene precio de mayoreo si esta definido o tabulador de precio
					SELECT pma.precio
					FROM tbl_precios_mayoreo AS pma
					WHERE pma.id_producto = in_id_producto
						AND pma.id_sucursal IN (0, in_id_sucursal)
					ORDER BY pma.id_sucursal DESC
					LIMIT 1
				), pp.precio, prd.precio_venta),
				COALESCE(pp.cantidad, 0)
			INTO @precio_unitario,
				@precio_mayoreo,
				@cantidad
			FROM cat_productos_servicios AS prd
			JOIN cat_sucursales AS suc
				ON suc.id_sucursal = in_id_sucursal
			LEFT OUTER JOIN tbl_precios_productos AS pp
				ON pp.id_producto = prd.id_producto
					AND pp.id_sucursal = in_id_sucursal
					AND pp.cantidad <= in_cantidad
			WHERE prd.id_producto = in_id_producto
			ORDER BY pp.cantidad DESC
			LIMIT 1;
		ELSE
			-- Si no existen tabuladores de precios definidos para la sucursal, obtenemos
			-- el tabulador de precios de la lista general de precios (id_sucursal = 0).
			-- Si no se encuentra el tabulador correspondiente, devuelve precio general
			-- del producto.
			SELECT COALESCE(pp.precio, prd.precio_venta),
				COALESCE(( -- Obtiene precio de mayoreo si esta definido o tabulador de precio
					SELECT pma.precio
					FROM tbl_precios_mayoreo AS pma
					WHERE pma.id_producto = in_id_producto
						AND pma.id_sucursal IN (0, in_id_sucursal)
					ORDER BY pma.id_sucursal DESC
					LIMIT 1
				), pp.precio, prd.precio_venta),
				COALESCE(pp.cantidad, 0)
			INTO @precio_unitario,
				@precio_mayoreo,
				@cantidad
			FROM cat_productos_servicios AS prd
			JOIN cat_sucursales AS suc
				ON suc.id_sucursal = in_id_sucursal
			LEFT OUTER JOIN tbl_precios_productos AS pp
				ON pp.id_producto = prd.id_producto
					AND pp.id_sucursal = 0 -- ID 0 = Lista aplicable a todas las sucursales
					AND pp.cantidad <= in_cantidad
			WHERE prd.id_producto = in_id_producto
			ORDER BY pp.cantidad DESC
			LIMIT 1;
		END IF;
	END IF;
	
	SELECT @precio_unitario AS precio_unitario,
		@precio_mayoreo AS precio_mayoreo,
		@cantidad AS cantidad_precio,
		@oferta AS precio_oferta;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_preciosProducto`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_preciosProducto`(
	in_id_sucursal INT,
	in_id_producto INT
)
    SQL SECURITY INVOKER
    COMMENT 'Obtiene la imagen por default para productos sin foto'
BEGIN
	IF EXISTS (
		SELECT id_producto FROM tbl_precios_productos
		WHERE id_sucursal = in_id_sucursal
			AND id_producto = in_id_producto
	) THEN
		-- Obtenemos lista de precios para la sucursal
		SELECT pp.cantidad,
			pp.precio
		FROM tbl_precios_productos AS pp
		WHERE pp.id_producto = in_id_producto
			AND pp.id_sucursal = in_id_sucursal
		ORDER BY pp.cantidad;
	ELSE
		-- Obtenemos lista de precios general
		SELECT pp.cantidad,
			pp.precio
		FROM tbl_precios_productos AS pp
		WHERE pp.id_producto = in_id_producto
			AND pp.id_sucursal = 0
		ORDER BY pp.cantidad;
	END IF;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_producto_x_codigo`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_producto_x_codigo`(
	p_codigo VARCHAR(30)
)
    SQL SECURITY INVOKER
    COMMENT 'Búsqueda de Producto por Código'
BEGIN
	SELECT 1 AS cantidad,
		prd.modelo,
		prd.nombre AS descripcion,
		prd.precio_venta AS precio_unitario,
		prd.precio_venta,
		0.00 AS subtotal,
		0.00 AS iva,
		0.00 AS total,
		prd.tasa_iva,
		prd.iva_incluido,
		prd.imagen,
		prd.id_producto,
		prd.clave
	FROM cat_productos_servicios AS prd
	JOIN cat_configuracion AS cfg
	WHERE BINARY prd.clave = p_codigo
		OR BINARY LEFT(prd.clave, cfg.group_len) = p_codigo;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_retiroCaja`(
	in_id_retiro INT
)
    SQL SECURITY INVOKER
    COMMENT 'Informacion de retiro de caja'
BEGIN
	SELECT cc.*,
		CAST(cc.fecha_retiro AS DATE) AS fecha,
		SUBSTRING(cc.fecha_retiro, 12) AS hora,
		uc.nombre AS usuario_caja,
		ua.nombre AS usuario_retiro
	FROM tbl_retiros AS cc
	JOIN tbl_usuarios AS uc
		ON uc.id_user = cc.id_usuario_caja
	JOIN tbl_usuarios AS ua
		ON ua.id_user = cc.id_usuario_retiro
	WHERE cc.id_retiro = in_id_retiro;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_syncVentaDetail`(
	in_id_movimiento INT
)
    SQL SECURITY INVOKER
    COMMENT 'Recupera los registros del detalle de una venta'
BEGIN
	SELECT dm.id_producto,
		p.id_unidad_medida,
		CAST(dm.cantidad AS UNSIGNED) AS cantidad,
		dm.precio_unitario
	FROM tbl_movimientos_detalle AS dm
	JOIN cat_productos_servicios AS p
		ON p.id_producto = dm.id_producto
	WHERE dm.id_movimiento = in_id_movimiento;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_syncVentas`(
)
    SQL SECURITY INVOKER
    COMMENT 'Recupera las ventas pendientes de syncronizar'
BEGIN
	SELECT * FROM tbl_movimientos AS m
	WHERE m.id_tipo_movimiento = 1
		AND pagado >= total
		AND consolidado IS NULL;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_updateProducto`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_updateProducto`(
	in_id_producto INT,
	in_clave VARCHAR(20),
	in_nombre VARCHAR(100),
	in_modelo VARCHAR(100),
	in_descripcion TEXT,
	in_precio_venta DECIMAL(15,2),
	in_tasa_iva DECIMAL(7,2),
	in_peso VARCHAR(15),
	in_longitud VARCHAR(15),
	in_superficie VARCHAR(15),
	in_volumen VARCHAR(15),
	in_id_unidad_medida INT,
	in_tipo_producto INT,
	in_iva_incluido INT,
	in_imagen TEXT
)
    SQL SECURITY INVOKER
    COMMENT 'Inserta o actualiza un Producto'
BEGIN
	INSERT INTO cat_productos_servicios
	SET id_producto = in_id_producto,
		clave = in_clave,
		nombre = in_nombre,
		modelo = in_modelo,
		descripcion = in_descripcion,
		precio_venta = in_precio_venta,
		tasa_iva = in_tasa_iva,
		peso = in_peso,
		longitud = in_longitud,
		superficie = in_superficie,
		volumen = in_volumen,
		id_unidad_medida = in_id_unidad_medida,
		tipo_producto = in_tipo_producto,
		iva_incluido = in_iva_incluido,
		imagen = in_imagen
	ON DUPLICATE KEY
	UPDATE clave = in_clave,
		nombre = in_nombre,
		modelo = in_modelo,
		descripcion = in_descripcion,
		precio_venta = in_precio_venta,
		tasa_iva = in_tasa_iva,
		peso = in_peso,
		longitud = in_longitud,
		superficie = in_superficie,
		volumen = in_volumen,
		id_unidad_medida = in_id_unidad_medida,
		tipo_producto = in_tipo_producto,
		iva_incluido = in_iva_incluido,
		imagen = in_imagen;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_updateUrls`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_updateUrls`(
	in_url_sucursales TEXT,
	in_url_productos TEXT,
	in_url_precios TEXT,
	in_url_existencias TEXT,
	in_url_ventas TEXT
)
    SQL SECURITY INVOKER
    COMMENT 'Guarda la configuracion de Urls para sincronicazion de catalogos'
BEGIN
	UPDATE cat_configuracion
	SET url_sync_sucursales = in_url_sucursales,
		url_sync_productos = in_url_productos,
		url_sync_precios = in_url_precios,
		url_existencias = in_url_existencias,
		url_sync_ventas = in_url_ventas;
END$$
DELIMITER ;


/* Create Procedure in target  */

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_validarAutorizacion`(
	in_password TEXT,
	in_permiso TEXT
)
    SQL SECURITY INVOKER
    COMMENT 'Verifica usuario con contraseña y permiso'
BEGIN
	SELECT u.id_user
	FROM tbl_usuarios AS u
	WHERE BINARY user_pass = in_password
		AND INSTR(u.permisos, in_permiso) > 0
		AND u.activo = 1;
END$$
DELIMITER ;


/*  Alter Procedure in target  */

DELIMITER $$
DROP PROCEDURE IF EXISTS `stp_ventaDetail`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `stp_ventaDetail`(
	in_id_movimiento INT
)
    SQL SECURITY INVOKER
    COMMENT 'Recupera los registros del detalle de una venta'
BEGIN
	SELECT dm.id_producto,
		p.clave AS codigo,
		p.nombre,
		p.descripcion,
		CAST(dm.cantidad AS UNSIGNED) AS cantidad,
		dm.precio_unitario,
		dm.subtotal,
		dm.total,
		p.modelo
	FROM tbl_movimientos_detalle AS dm
	JOIN cat_productos_servicios AS p
		ON p.id_producto = dm.id_producto
	WHERE dm.id_movimiento = in_id_movimiento;
END$$
DELIMITER ;

